#include "mididriver_reply.h"
#include <mach/mach_types.h>
#include <mach/message.h>
#include <mach/mig_errors.h>
#include <mach/msg_type.h>
#if	!defined(KERNEL) && !defined(MIG_NO_STRINGS)
#include <strings.h>
#endif
/* LINTLIBRARY */

extern port_t mig_get_reply_port();
extern void mig_dealloc_reply_port();

#ifndef	mig_internal
#define	mig_internal	static
#endif

#ifndef	TypeCheck
#define	TypeCheck 1
#endif

#ifndef	UseExternRCSId
#ifdef	hc
#define	UseExternRCSId		1
#endif
#endif

#ifndef	UseStaticMsgType
#if	!defined(hc) || defined(__STDC__)
#define	UseStaticMsgType	1
#endif
#endif

#define msg_request_port	msg_remote_port
#define msg_reply_port		msg_local_port


/* SimpleRoutine MDAlarmReply */
mig_external kern_return_t MDAlarmReply (
	port_t reply_port,
	int requestedTime,
	int actualTime)
{
	typedef struct {
		msg_header_t Head;
		msg_type_t requestedTimeType;
		int requestedTime;
		msg_type_t actualTimeType;
		int actualTime;
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;

	unsigned int msg_size = 40;

#if	UseStaticMsgType
	static const msg_type_t requestedTimeType = {
		/* msg_type_name = */		MSG_TYPE_INTEGER_32,
		/* msg_type_size = */		32,
		/* msg_type_number = */		1,
		/* msg_type_inline = */		TRUE,
		/* msg_type_longform = */	FALSE,
		/* msg_type_deallocate = */	FALSE,
		/* msg_type_unused = */		0,
	};
#endif	UseStaticMsgType

#if	UseStaticMsgType
	static const msg_type_t actualTimeType = {
		/* msg_type_name = */		MSG_TYPE_INTEGER_32,
		/* msg_type_size = */		32,
		/* msg_type_number = */		1,
		/* msg_type_inline = */		TRUE,
		/* msg_type_longform = */	FALSE,
		/* msg_type_deallocate = */	FALSE,
		/* msg_type_unused = */		0,
	};
#endif	UseStaticMsgType

#if	UseStaticMsgType
	InP->requestedTimeType = requestedTimeType;
#else	UseStaticMsgType
	InP->requestedTimeType.msg_type_name = MSG_TYPE_INTEGER_32;
	InP->requestedTimeType.msg_type_size = 32;
	InP->requestedTimeType.msg_type_number = 1;
	InP->requestedTimeType.msg_type_inline = TRUE;
	InP->requestedTimeType.msg_type_longform = FALSE;
	InP->requestedTimeType.msg_type_deallocate = FALSE;
#endif	UseStaticMsgType

	InP->requestedTime /* requestedTime */ = /* requestedTime */ requestedTime;

#if	UseStaticMsgType
	InP->actualTimeType = actualTimeType;
#else	UseStaticMsgType
	InP->actualTimeType.msg_type_name = MSG_TYPE_INTEGER_32;
	InP->actualTimeType.msg_type_size = 32;
	InP->actualTimeType.msg_type_number = 1;
	InP->actualTimeType.msg_type_inline = TRUE;
	InP->actualTimeType.msg_type_longform = FALSE;
	InP->actualTimeType.msg_type_deallocate = FALSE;
#endif	UseStaticMsgType

	InP->actualTime /* actualTime */ = /* actualTime */ actualTime;

	InP->Head.msg_simple = TRUE;
	InP->Head.msg_size = msg_size;
	InP->Head.msg_type = MSG_TYPE_NORMAL;
	InP->Head.msg_request_port = reply_port;
	InP->Head.msg_reply_port = PORT_NULL;
	InP->Head.msg_id = 400;

	return msg_send(&InP->Head, SEND_SWITCH, 0);
}

/* SimpleRoutine MDDataReply */
mig_external kern_return_t MDDataReply (
	port_t reply_port,
	short unit,
	MDRawEventPtr data,
	unsigned int dataCnt)
{
	typedef struct {
		msg_header_t Head;
		msg_type_t unitType;
		short unit;
		char unitPad[2];
		msg_type_t dataType;
		MDRawEvent data[100];
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;

	unsigned int msg_size = 36;
	/* Maximum request size 836 */
	unsigned int msg_size_delta;

#if	UseStaticMsgType
	static const msg_type_t unitType = {
		/* msg_type_name = */		MSG_TYPE_INTEGER_16,
		/* msg_type_size = */		16,
		/* msg_type_number = */		1,
		/* msg_type_inline = */		TRUE,
		/* msg_type_longform = */	FALSE,
		/* msg_type_deallocate = */	FALSE,
		/* msg_type_unused = */		0,
	};
#endif	UseStaticMsgType

#if	UseStaticMsgType
	static const msg_type_t dataType = {
		/* msg_type_name = */		MSG_TYPE_BYTE,
		/* msg_type_size = */		8,
		/* msg_type_number = */		800,
		/* msg_type_inline = */		TRUE,
		/* msg_type_longform = */	FALSE,
		/* msg_type_deallocate = */	FALSE,
		/* msg_type_unused = */		0,
	};
#endif	UseStaticMsgType

#if	UseStaticMsgType
	InP->unitType = unitType;
#else	UseStaticMsgType
	InP->unitType.msg_type_name = MSG_TYPE_INTEGER_16;
	InP->unitType.msg_type_size = 16;
	InP->unitType.msg_type_number = 1;
	InP->unitType.msg_type_inline = TRUE;
	InP->unitType.msg_type_longform = FALSE;
	InP->unitType.msg_type_deallocate = FALSE;
#endif	UseStaticMsgType

	InP->unit /* unit */ = /* unit */ unit;

#if	UseStaticMsgType
	InP->dataType = dataType;
#else	UseStaticMsgType
	InP->dataType.msg_type_name = MSG_TYPE_BYTE;
	InP->dataType.msg_type_size = 8;
	InP->dataType.msg_type_inline = TRUE;
	InP->dataType.msg_type_longform = FALSE;
	InP->dataType.msg_type_deallocate = FALSE;
#endif	UseStaticMsgType

	if (dataCnt > 100)
		return MIG_ARRAY_TOO_LARGE;
	bcopy((char *) data, (char *) InP->data, 8 * dataCnt);

	InP->dataType.msg_type_number /* 8 dataCnt */ = /* dataType.msg_type_number */ 8 * dataCnt;

	msg_size_delta = 8 * dataCnt;
	msg_size += msg_size_delta;

	InP->Head.msg_simple = TRUE;
	InP->Head.msg_size = msg_size;
	InP->Head.msg_type = MSG_TYPE_NORMAL;
	InP->Head.msg_request_port = reply_port;
	InP->Head.msg_reply_port = PORT_NULL;
	InP->Head.msg_id = 401;

	return msg_send(&InP->Head, SEND_SWITCH, 0);
}

/* SimpleRoutine MDExceptionReply */
mig_external kern_return_t MDExceptionReply (
	port_t reply_port,
	int exception_code)
{
	typedef struct {
		msg_header_t Head;
		msg_type_t exception_codeType;
		int exception_code;
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;

	unsigned int msg_size = 32;

#if	UseStaticMsgType
	static const msg_type_t exception_codeType = {
		/* msg_type_name = */		MSG_TYPE_INTEGER_32,
		/* msg_type_size = */		32,
		/* msg_type_number = */		1,
		/* msg_type_inline = */		TRUE,
		/* msg_type_longform = */	FALSE,
		/* msg_type_deallocate = */	FALSE,
		/* msg_type_unused = */		0,
	};
#endif	UseStaticMsgType

#if	UseStaticMsgType
	InP->exception_codeType = exception_codeType;
#else	UseStaticMsgType
	InP->exception_codeType.msg_type_name = MSG_TYPE_INTEGER_32;
	InP->exception_codeType.msg_type_size = 32;
	InP->exception_codeType.msg_type_number = 1;
	InP->exception_codeType.msg_type_inline = TRUE;
	InP->exception_codeType.msg_type_longform = FALSE;
	InP->exception_codeType.msg_type_deallocate = FALSE;
#endif	UseStaticMsgType

	InP->exception_code /* exception_code */ = /* exception_code */ exception_code;

	InP->Head.msg_simple = TRUE;
	InP->Head.msg_size = msg_size;
	InP->Head.msg_type = MSG_TYPE_NORMAL;
	InP->Head.msg_request_port = reply_port;
	InP->Head.msg_reply_port = PORT_NULL;
	InP->Head.msg_id = 402;

	return msg_send(&InP->Head, SEND_SWITCH, 0);
}

/* SimpleRoutine MDQueueReply */
mig_external kern_return_t MDQueueReply (
	port_t reply_port,
	short unit)
{
	typedef struct {
		msg_header_t Head;
		msg_type_t unitType;
		short unit;
		char unitPad[2];
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;

	unsigned int msg_size = 32;

#if	UseStaticMsgType
	static const msg_type_t unitType = {
		/* msg_type_name = */		MSG_TYPE_INTEGER_16,
		/* msg_type_size = */		16,
		/* msg_type_number = */		1,
		/* msg_type_inline = */		TRUE,
		/* msg_type_longform = */	FALSE,
		/* msg_type_deallocate = */	FALSE,
		/* msg_type_unused = */		0,
	};
#endif	UseStaticMsgType

#if	UseStaticMsgType
	InP->unitType = unitType;
#else	UseStaticMsgType
	InP->unitType.msg_type_name = MSG_TYPE_INTEGER_16;
	InP->unitType.msg_type_size = 16;
	InP->unitType.msg_type_number = 1;
	InP->unitType.msg_type_inline = TRUE;
	InP->unitType.msg_type_longform = FALSE;
	InP->unitType.msg_type_deallocate = FALSE;
#endif	UseStaticMsgType

	InP->unit /* unit */ = /* unit */ unit;

	InP->Head.msg_simple = TRUE;
	InP->Head.msg_size = msg_size;
	InP->Head.msg_type = MSG_TYPE_NORMAL;
	InP->Head.msg_request_port = reply_port;
	InP->Head.msg_reply_port = PORT_NULL;
	InP->Head.msg_id = 403;

	return msg_send(&InP->Head, SEND_SWITCH, 0);
}
